
const int MOVIE_FPS=10;

//----- Intialize / increment a filename of form xyz001.bmp, xyz002.bmp, ... 
class CIncrementName { 
	public : 
		bool m_bError;
		int m_iDotPos;
		char m_achName[_MAX_PATH];
		CIncrementName( const char * pch );
		char * NextName();
	};

//----- GEM Movie file - series of bitmaps, sounds, data info and ability to write BMP or SWF series of frames
class CMovie { 
	public : 
		CMovie();
		~CMovie();

		//-- Array of bitmaps.  Load xyz0001.bmp will load also xyz002.bmp, etc.
		bool LoadBitmaps( const char * pchFile, int iCount );
		CItemArray m_aBMP;
		bool BMPLoad( const char * pchFile );
		CBMP * BMP( int iBMP );
		int m_iBMPMaxWidth;
		int m_iBMPMaxHeight;

		//-- Array of bitmaps.  Load xyz0001.bmp will load also xyz002.bmp, etc.
		bool LoadSounds( const char * pchFile, int iCount );
		CItemArray m_aWAV;
		bool WAVLoad( const char * pchFile );

		CString m_cImageFile;	// 
		CString m_cSoundFile;
		CString m_cBMPName;
		CString m_cSWFName;

		CString m_cDataName;
		int m_iDataSelect;		// 0=all 1=list 2=selection
	
		short m_iX0Data, m_iX1Data;		// Location of data window
		short m_iY0Data, m_iY1Data;		
		short m_iX0State, m_iX1State;	// Location of State window
		short m_iY0State, m_iY1State;		
		
		short m_iChannel;
		
		bool m_bFrame;			// Data components to draw
		bool m_bFill;
		bool m_bData;
		bool m_bHighlight;
		bool m_bIndicator;
		bool m_bState;
		bool m_bClass;
		COLORREF m_crFrame;		
		COLORREF m_crFill;
		COLORREF m_crData;
		COLORREF m_crHighlight;
		COLORREF m_crIndicator;
		COLORREF m_crState;
		COLORREF m_crClass;
		
		int m_iMinFrames;		// limit frames per event
		int m_iMaxFrames;
		int m_iMovieSeconds;	// total movie length to produce

		//-- Renderable data		ProcessData()
		short * m_aiDispLow;		// Reduce m_adData to data block with pixels between 
		short * m_aiDispHigh;		// ... m_aiLow[i]:m_aiHigh[i] for i=0..dispWidth set.
		short * m_aiDispClass;		// decimate aiClass to aiDispClass
		short * m_aiDispState;		// decimate aiState to aiDispState
		int m_iRenderLen;
		bool AllocateRender( int iLen );
		bool DrawDataBlock( int iPosData, int iPosState, CBMP * pBmp, bool bIndicator );

		bool SaveFile( const char * pch = NULL );	// save settings in a file 
		bool LoadFile( const char * pch = NULL );	// load settings from a file
		
		bool ExportBmp( const char * pchFile, int iDataLen, short * aiState );
		bool ExportSwf( const char * pchFile, int iDataLen, short * aiState );

	private :
		int m_iStatus;				
	public : 
		bool SetStatus( int iStatus );
		int GetStatus();		
		
	};

	